// This is a personal academic project. Dear PVS-Studio, please check it.
// PVS-Studio Static Code Analyzer for C, C++, C#, and Java: https://pvs-studio.com
//
// ┏━┓┏━┓┏━━┓  ┏━━━┓┏━━━┓┏━━━┓  ┏┓┏━━━┓┏━━━┓┏━━━━┓
// ┃┃┗┛┃┃┗┫┣┛  ┃┏━┓┃┃┏━┓┃┃┏━┓┃  ┃┃┃┏━━┛┃┏━┓┃┃┏┓┏┓┃
// ┃┏┓┏┓┃ ┃┃   ┃┗━┛┃┃┗━┛┃┃┃ ┃┃  ┃┃┃┗━━┓┃┃ ┗┛┗┛┃┃┗┛
// ┃┃┃┃┃┃ ┃┃   ┃┏━━┛┃┏┓┏┛┃┃ ┃┃┏┓┃┃┃┏━━┛┃┃ ┏┓  ┃┃
// ┃┃┃┃┃┃┏┫┣┓┏┓┃┃   ┃┃┃┗┓┃┗━┛┃┃┗┛┃┃┗━━┓┃┗━┛┃ ┏┛┗┓
// ┗┛┗┛┗┛┗━━┛┗┛┗┛   ┗┛┗━┛┗━━━┛┗━━┛┗━━━┛┗━━━┛ ┗━━┛
// ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━ ━

#pragma once

#include <MI/Mesh/MeshElement/MI.Quad.h>
#include <MI/Mesh/MeshElement/MI.Triangle.h>

#include <MI/Common/MI.Error.h>
#include <MI/Mesh/MI.Mesh.hpp>
#include <MI/Mesh/MI.SimplexNode.hpp>
#include <MI/Container/MI.Matrix.hpp>

//
// tex:
// Качество элемента (mean ratio quality).
// $$R^{2} - \text{2D сетка}$$
// $$R^{3} - \text{3D сетка}$$
// $$E := (p_{1}, ..., p_{|E|}) \text{ обозначает элемент с }|E|\text{ узлами, которые могут быть:}$$
// $$\text{треугольными или четырехугольными в } R^2, $$
// $$\text{тетраэдрический, шестигранный, пирамидальный или призматический в } R^3.$$
// Каждая вершина $p_i ∈ R_m, m ∈ \{2, 3\}$, любого элемента соединена ребрами с $m$ другими вершинами $p_j$ того же
// элемента.

// tex:
//  В качестве предварительного условия определения критерия качества среднего отношения должны быть определены
//  конкретные условия достоверности элемента. Валидность элемента также будет оцениваться на основе симплекс-узлов,
//  которые сначала будут отображаться более точно. В дальнейшем элемент определенного типа будет обозначаться
//  как $E_{tri}$, $E_{quad}$, $E_{tet}$, $E_{hex}$ соответственно. Индексы симплекс-узлов для соответствующего типа
//  элемента задаются кортежами:
//  $$ [N_{tri}, N_{quad}, N_{tet}, N_{hex}] - \text{Симплекс узел - симплекс, который определяют каждый узел и его
//  реберно-связные соседи.}$$
//  $$N_{tri}  := \{(0, 1, 2)\} $$
//  $$N_{quad} := \{(0, 1, 3), (1, 2, 0), (2, 3, 1), (3, 0, 2)\} $$
//  $$N_{tet}  := \{(0, 1, 2, 3)\} $$
//  $$N_{hex}  := \{(0, 3, 4, 1), (1, 0, 5, 2), (2, 1, 6, 3), (3, 2, 7, 0),
//                  (4, 7, 5, 0), (5, 4, 6, 1), (6, 5, 7, 2), (7, 6, 4, 3)\}$$
//  $$ |N| - \text{Число симплексов узлов, т.е. количество элементов в кортеже N.}$$
//  $$ p_i - \text{i-ая вершина элемента.}$$
//  $$ k - \text{номер элемента. tri == 0, quad == 1, tet == 2, hex == 3.}$$
//  $$ m - \text{кол-во векторов в симплекс узле (2 для R2, 3 для R3).}$$
//  $$ W - \text{Весовая матрица. Матрица симплекс узла для идеального элемента с длиной сторон равной 1.}$$

// <image src="../../../docs/img/Weight matrices W.png" scale = "0.6"/>
// Рис. 1.

// tex:
//  Даны примеры таких симплексов, связанных с $pис. 1$, которые отмечены серым цветом для всех типов элементов. Здесь
//  данные элементы являются правильными, и первые два узла имеют координаты:
//  $$p_1 = (0, 0) \text{ и } p_2 = (1, 0),    \text{ при } m = 2.$$
//  $$p_1 = (0, 0, 0) \text{ и } p_2 = (1, 0, 0), \text{ при } m = 3.$$

// tex:
//   В этом представлении $k$-й элемент $N ∈ {\{}N_{tri}, N_{quad}, N_{tet}, N_{hex}{\}}$ представляет $m + 1$ узловых
//   индексов $N_{k, i}$, $i ∈ \{0, ..., m\}$ симплекс-узла, связанного с $p_{k}$. Следует отметить, что в случае
//   $E_{tri}$ и $E_{tet}$ каждый из $m + 1$ узловых симплексов представляет сам элемент. Следовательно, достаточно
//   использовать только симплекс узла, связанный с $p$, что приводит к $|N_{tri}| == |N_{tet}| == 1$. Следовательно,
//   для треугольного и тетраэдрического элементов справедливо выражение $|E| != |N|$.

// tex:
//   $\text{Определение 1 (Действительность элемента).}\\$
//   Пусть $E$ обозначает произвольный элемент, взятый из $\{E_{tri}, E_{quad}, E_{tet}, E_{hex}\}$ со связанным с ним
//   кортежем симплексов узлов, заданным $N ∈ \{N_{tri}, N_{quad}, N_{tet}, N_{hex}\}$. Для каждого узла
//   $p_{k}, k ∈ \{0, ..., |N-1|\}$, пусть:
//   $$T_{k}    := (p_{N_{k, 1}}, ..., p_{N_{k, m + 1}}) - \text{симплекс-узел}$$
//   $$D(T_k) := (p_{N_{k, 2}} − p_{N_{k, 1}}, ..., p_{N_{k, m + 1}} p_{N_{k, 1}}) - \text{матрица } m × m \text{ ее
//   остовных краевых векторов.}$$ Элемент называется действительным, если $det(D(T_k)) > 0$. выполняется для всех $k ∈
//   {\{}0, ..., |N-1|{\}}$. В противном случае он называется недействительным.

// tex:
//   $\text{Определение 2 (Качество элемента).}\\$
//   Качество элемента задается формулой:
//   $$ q(E) = \frac{1}{N} * \sum\limits_{k=1}^N \frac{m * (det(S_{k}))^{\frac{2}{m}}}{trace(S^_t{k} * S_{k})}, (1) $$
//
//   где:
//   $$ S_{k} = D(T_{k}) * W ^ {-1} $$
//   $$trace(S_{kt} * S_{k}) - \text{это сумма квадратов всех элементов } (\text{квадрат нормы Фробениуса матрицы }
//   S_{k})$$
//   $$E - \text{произвольный допустимый элемент, взятый из } {\{} E_{tri}, E_{quad}, E_{tet}, E_{hex} {\}} $$
//   $$N - \text{связанный с } E \text{ кортеж индексов узловых тетраэдров } T_{k} ∈ {\{}N_{tri}, N_{quad}, N_{tet},
//   N_{hex} {\}} \text{в соответствии с рис. 1.}$$
//   $$S_k = D(T_k) * W^{-1}$$
//   $$trace(S^k_{t} * S_k) - \text{это сумма квадратов всех элементов (квадрат нормы Фробениуса матрицы }S_k{)}$$
//   $$E - \text{произвольный допустимый элемент, взятый из }{\{}E_{tri}, E_{quad}, E_{tet}, E_{hex}{\}}$$
//   $$N - \text{связанный с }E\text{ кортеж индексов узловых тетраэдров } Tk ∈ {\{}N_{tri}, N_{quad}, N_{tet},
//   N_{hex}{\}} \text{в соответствии с рис. 1.}$$
//
//   Качество элемента $q(E) ∈ (0, 1]$.
//   Следует также отметить, что знаменатель в $(1)$ представляет квадрат нормы Фробениуса матрицы $S_k$. Здесь и далее
//   максимальное количество недействительных элементов в сетке устанавливается равным нулю.
//
//   Каждая узловая координата элемента представляет собой степень свободы. Следовательно, представляя один элемент
//   вещественным числом качества, очевидно, что разные элементы, имеющие одно и то же качество, могут отличаться
//   по форме.
//
//   Если элемент недействительный (используется "MI is_degenerated"), то сразу возвращается 0.0.

// Весовые матрицы.
// ================
//
// Весовая матрица - это три вектора для одного симплекс-узла идеального элемента.
// Длина каждого вектора должна быть равной единице (В ВЕСОВОЙ МАТРИЦЕ).
//
// Возьмем элемент,            Симплекс узел
// например quad.              для вершины 'A'.
//
// D     C                     D
//  +---+                       +
//  |\  |                       ^\
//  | \ |                       | \
//  |  \|                       |  \
//  +---+                       +-->+
// A     B                     A     B
//
// v1 = B - A;
// v2 = D - A;
//
// w1 = | v1.x, v2.x |
//      | v1.y, v2.y |
//
// Для 2d элементов количество векторов у симплекс узла должно быть 2 (m = 2).
// Для 3d элементов количество векторов у симплекс узла должно быть 3 (m = 3).
// (НО!) Тогда все 2d элементы должны лежать в плоскости 'z', но наша сетка не может быть не плоской, элементы не
// будут лежать в плоскости 'z'. Тогда весовая матрица будет (НЕ) квадратной, потому что нам нужно будет использовать
// все координаты (x, y, z).
//
// w2 = | v1.x, v2.x |
//      | v1.y, v2.y |
//      | v1.z, v2.z |
//
// С такой матрицей нельзя будет работать в дальнейшем.
// Решить эту проблему можно несколькими способами:
// - Спроецировать элемент на плоскость 'z' и использовать w1.
// - Добавить третий вектор (v3), который будет перпендикулярным к v1 и к v2
//    и иметь длину v3.len == (v1.len + b2.len) / 2.
//    Тогда матрица будет квадратной:
//
//    w3 = | v1.x, v2.x, v3.x |
//         | v1.y, v2.y, v3.y |
//         | v1.z, v2.z, v3.z |
//
// Я решил выбрать второй способ, потому что quad может быть искривленным, тогда спроецировать его на плоскость 'z'
// никак не получится.

// tex:
//   Весовые матрицы для основных элементов:
//
//   \[
//     E_{tri}{2 \times 2} =
//     \ {\begin{pmatrix}
//          1 & \frac{1}{2} \\
//     0 & \frac{\sqrt{3}}{2} \\
//   \end{pmatrix} }
//   \]
//   \[
//     E_{quad}{2 \times 2} =
//     \ {\begin{pmatrix}
//          1 & 0 \\
//     0 & 1 \\
//   \end{pmatrix} }
//   \]
//   \[
//     E_{tet}{3\times 3} =
//     \ {\begin{pmatrix}
//          1 & \frac{1}{2} & \frac{1}{2} \\
//     0 & \frac{\sqrt{3}}{2} & \frac{\sqrt{3}}{6} \\
//     0 & 0 & \sqrt{\frac{2}{3}} \\
//   \end{pmatrix} }
//   \]
//
//   \[
//     E_{hex}{3 \times 3} =
//     \ {\begin{pmatrix}
//          1 & 0 & 0  \\
//     0 & 1 & 0  \\
//     0 & 0 & 1  \\
//   \end{pmatrix} }
//   \]
namespace mi {
MI_NODISCARD MI_BASE_EXPORT ErrorOr<double> quality(const MI Triangle& element, const MI Mesh& mesh);

MI_NODISCARD MI_BASE_EXPORT ErrorOr<double> quality(const MI Quad& element, const MI Mesh& mesh);

MI_NODISCARD MI_BASE_EXPORT ErrorOr<double> quality(const MI MeshElement* element, const MI Mesh& mesh);

namespace internal {
MI_NODISCARD MI_BASE_EXPORT ErrorOr<double> quality_quad_impl(const MI static_vector<point3d, 4>& vv);
}  // namespace internal
}  // namespace mi
